/**
 * Services container
 */
class Services
{
	/// Memory - the storage of class
	Mem = Memory();
	
	static function New (src, dst, cargoid)
	{

		assert(src instanceof Servable);
		assert(dst instanceof Servable);
		local serv = Services();
		serv.Mem.ID = 0;
		serv.Mem.Key = Services.CreateID(src.GetID(), dst.GetID(), cargoid);
        serv.Mem.Skipped = false;		
		return serv;
	}

    /**
     * Make service ID
     * @param source Source ID
     * @param dest Destination ID
     * @param cargo Cargo ID
     * @return ID of service table
     */
    static function CreateID(source, dest, cargo)
    {
        return Assist.LeadZero(source) + ":" + Assist.LeadZero(dest) + ":" + Assist.LeadZero(cargo) ;
    }

	/**
	 * Make class from storage
	 * @param storage to build the class from
	 * @return Service class
	 */
	static function MakeClass(storage)
	{
		assert(typeof(storage) == "table");
		local tmp = Services();
		tmp.Mem.SetStorage(storage);
		return tmp;
	}
}
